class SBTrophyDude extends Decoration;
// V0 created 21 Apr 2017 by SeriousBarbie at googlemail makeadot com
// V1 created 24 Apr 2017: added MultiSkins(0) and MultiSkins(3)

#exec OBJ LOAD FILE="..\Textures\commandoskins.utx"

var() byte AnimTrophyWeight[5];
var() name AnimTrophyEvent[5];

var int AnimWeightSum;

var int Weights[5];
var name StrToNameHack;


function name GetCurrentAnimName(byte i) {
	SetPropertyText("StrToNameHack", 'Trophy' $ i);
	return StrToNameHack;
}

event PostBeginPlay() {
local byte i;
	for (i = 0; i < ArrayCount(AnimTrophyWeight); i++)
	{
		Weights[i] = AnimTrophyWeight[i] + AnimWeightSum;
		AnimWeightSum += AnimTrophyWeight[i];
	}
}


function Trigger(actor Other, pawn EventInstigator) {
local byte i;
local int RandWeight;
	if (AnimWeightSum == 0)
		return;
	RandWeight = Rand(AnimWeightSum);
	for (i = 0; i < ArrayCount(Weights); i++)
		if (Weights[i] >= RandWeight)
			break;
	PlayAnim(GetCurrentAnimName(i + 1));
	if (AnimTrophyEvent[i] != '')
		TriggerActors(Other, EventInstigator, AnimTrophyEvent[i]);
}


function TriggerActors(actor Other, pawn EventInstigator, Name EventName) {
local Actor A;
	foreach AllActors(Class'Actor', A, EventName)
		if (A != self)
			A.Trigger(Other, EventInstigator);
}


defaultproperties {
	AnimTrophyWeight(0)=10
	AnimTrophyWeight(1)=10
	AnimTrophyWeight(2)=10
	AnimTrophyWeight(3)=10
	AnimTrophyWeight(4)=10
	bCollideWorld=true
	bStatic=false
	CollisionHeight=40
	CollisionRadius=22
	DrawType=DT_Mesh
	Mesh=LodMesh'BotPack.TrophyMale1'
	MultiSkins(0)=Texture'commandoskins.cmdo1'
	MultiSkins(1)=Texture'commandoskins.cmdo2'
	MultiSkins(2)=Texture'commandoskins.cmdo3'
	MultiSkins(3)=Texture'commandoskins.cmdo4'
}